#### Contents of the preconfiguration file (for buster)
### Localization

# Preseeding only locale sets language, country and locale.
d-i debian-installer/locale string {{ machine.locale }}

# Keyboard selection.
d-i keyboard-configuration/xkb-keymap select {{ machine.keymap }}
# d-i keyboard-configuration/toggle select No toggling

### Network configuration
d-i netcfg/choose_interface select auto

# If you prefer to configure the network manually, uncomment this line and
# the static network configuration below.
d-i netcfg/disable_autoconfig boolean true

# wait up to 10 minutes for a IPv4 adress
#d-i netcfg/dhcp_timeout string 600
#d-i netcfg/dhcpv6_timeout string 1

# Static network configuration.
d-i netcfg/get_nameservers string {{ net_config.nameserver }}
d-i netcfg/get_ipaddress string {{ machine.net_config.address |ipv4('address') }}
d-i netcfg/get_netmask string {{ machine.net_config.address |ipv4('netmask') }}
d-i netcfg/get_gateway string {{ net_config.gateway }}
d-i netcfg/confirm_static boolean true

# Any hostname and domain names assigned from dhcp take precedence over
# values set here. However, setting the values still prevents the questions
# from being shown, even if values come from dhcp.
d-i netcfg/get_hostname string {{ machine.name }}
d-i netcfg/get_domain string {{ net_config.domain }}

# Disable that annoying WEP key dialog.
d-i netcfg/wireless_wep string

### Mirror settings
# If you select ftp, the mirror/country string does not need to be set.
#d-i mirror/protocol string ftp
d-i mirror/country string manual
d-i mirror/http/hostname string {{ machine.debian_config.mirror.hostname }}
d-i mirror/http/directory string {{ machine.debian_config.mirror.directory }}
d-i mirror/http/proxy string {{ machine.debian_config.mirror.proxy }}

# Suite to install.
d-i mirror/suite string {{ machine.debian_config.suite }}
# Suite to use for loading installer components (optional).
#d-i mirror/udeb/suite string testing

### Account setup
# Root account
{% if machine.root_user %}
d-i passwd/root-login boolean true
{% else %}
d-i passwd/root-login boolean false
d-i passwd/make-user boolean true 
{% endif %}
{% if machine.root_user.password_hash |d(False) %}
d-i passwd/root-password-crypted password {{ machine.root_user.password_hash }}
{% else %}
d-i passwd/root-password-crypted password {{ initial_root_password_hash }}
{% endif %}

# To create a normal user account.
{% if machine.extra_user %}
d-i passwd/user-fullname string {{ machine.extra_user.name }}
d-i passwd/username string {{ machine.extra_user.name }}
# or encrypted using a crypt(3) hash.
{% if machine.extra_user.password_hash |d(False) %}
d-i passwd/user-password-crypted password {{ machine.extra_user.password_hash }}
{% else %}
d-i passwd/user-password-crypted password {{ initial_extra_user_password_hash }}
{% endif %}
# Create the first user with the specified UID instead of the default.
d-i passwd/user-uid string {{ machine.extra_user.uid }}
# The user account will be added to some standard initial groups. To
# override that, use this.
d-i passwd/user-default-groups string 
{% endif %}

### Clock and time zone setup
# Controls whether or not the hardware clock is set to UTC.
d-i clock-setup/utc boolean {{ machine.use_utc |string |lower }}

# You may set this to any valid setting for $TZ; see the contents of
# /usr/share/zoneinfo/ for valid values.
d-i time/zone string {{ machine.timezone }}

# Controls whether to use NTP to set the clock during the install
d-i clock-setup/ntp boolean {{ machine.use_ntp |string |lower }}
# NTP server to use. The default is almost always fine here.
#d-i clock-setup/ntp-server string ntp.example.com

# Alternatively, you may specify a disk to partition. If the system has only
# one disk the installer will default to using that, but otherwise the device
# name must be given in traditional, non-devfs format (so e.g. /dev/sda
# and not e.g. /dev/discs/disc0/disc).
# For example, to use the first SCSI/SATA hard disk:
d-i partman-auto/disk string {{ machine.host_disk }}
# In addition, you'll need to specify the method to use.
# The presently available methods are:
# - regular: use the usual partition types for your architecture
# - lvm:     use LVM to partition the disk
# - crypto:  use LVM within an encrypted partition
d-i partman-auto/method string lvm

# You can define the amount of space that will be used for the LVM volume
# group. It can either be a size with its unit (eg. 20 GB), a percentage of
# free space or the 'max' keyword.
d-i partman-auto-lvm/guided_size string max

# If one of the disks that are going to be automatically partitioned
# contains an old LVM configuration, the user will normally receive a
# warning. This can be preseeded away...
d-i partman-lvm/device_remove_lvm boolean true
# The same applies to pre-existing software RAID array:
d-i partman-md/device_remove_md boolean true
# And the same goes for the confirmation to write the lvm partitions.
d-i partman-lvm/confirm boolean true
d-i partman-lvm/confirm_nooverwrite boolean true

# You can choose one of the three predefined partitioning recipes:
# - atomic: all files in one partition
# - home:   separate /home partition
# - multi:  separate /home, /var, and /tmp partitions
d-i partman-auto/choose_recipe select atomic

# This makes partman automatically partition without confirmation.
d-i partman-md/confirm boolean true
d-i partman-partitioning/confirm_write_new_label boolean true
d-i partman/choose_partition select finish
d-i partman/confirm boolean true
d-i partman/confirm_nooverwrite boolean true

## Controlling how partitions are mounted
# The default is to mount by UUID, but you can also choose "traditional" to
# use traditional device names, or "label" to try filesystem labels before
# falling back to UUIDs.
d-i partman/mount_style select uuid

### Base system installation
# Configure APT to not install recommended packages by default. Use of this
# option can result in an incomplete system and should only be used by very
# experienced users.
d-i base-installer/install-recommends boolean false

# The kernel image (meta) package to be installed; "none" can be used if no
# kernel is to be installed.
d-i base-installer/kernel/image string {{ machine.kernel_image }}

### Apt setup
# You can choose to install non-free and contrib software.
d-i apt-setup/non-free boolean true
d-i apt-setup/contrib boolean true
# Uncomment this if you don't want to use a network mirror.
#d-i apt-setup/use_mirror boolean false
# Select which update services to use; define the mirrors to be used.
# Values shown below are the normal defaults.
d-i apt-setup/services-select multiselect {{ machine.debian_config.updates |join(', ') }}
d-i apt-setup/security_host string {{ machine.debian_config.mirror.hostname }}

### Package selection
tasksel tasksel/first multiselect ssh-server

# Individual additional packages to install
#d-i pkgsel/include string openssh-server build-essential
# Whether to upgrade packages after debootstrap.
# Allowed values: none, safe-upgrade, full-upgrade
d-i pkgsel/upgrade select full-upgrade

# Some versions of the installer can report back on what software you have
# installed, and what software you use. The default is not to report back,
# but sending reports helps the project determine what software is most
# popular and include it on CDs.
popularity-contest popularity-contest/participate boolean {{ machine.debian_config.participate_popularity_contest }}

# This is fairly safe to set, it makes grub install automatically to the MBR
# if no other operating system is detected on the machine.
d-i grub-installer/only_debian boolean true

# This one makes grub-installer install to the MBR if it also finds some other
# OS, which is less safe as it might not be able to boot that other OS.
d-i grub-installer/with_other_os boolean false

# Due notably to potential USB sticks, the location of the MBR can not be
# determined safely in general, so this needs to be specified:
d-i grub-installer/bootdev  string {{ machine.host_disk }}
# To install to the first device (assuming it is not a USB stick):
d-i grub-installer/bootdev  string default

# This command is run just before the install finishes, but when there is
# still a usable /target directory. You can chroot to /target and use it
# directly, or use the apt-install and in-target commands to easily install
# packages and run commands in the target system.
#d-i preseed/late_command string apt-install zsh; in-target chsh -s /bin/zsh

d-i preseed/late_command string in-target apt update -y; \
    in-target apt install -y sudo python3; \
    in-target mkdir -p /etc/sudoers.d; \
{% if machine.root_user %}
{%   if machine.root_user.password_hash |d(False) == '!' %}
    in-target password -l root; \
{%   endif %}
{%   if machine.root_user.ssh_pub_keys %}
    in-target mkdir -p /root/.ssh; \
    in-target chown -R root:root /root; \
{%     for entry in machine.root_user.ssh_pub_keys |d([]) %}
    printf "# {{ entry.name |d('') }}\n{{ entry.key }}" >> /target/root/.ssh/authorized_keys; \
{%     endfor %}
{%   endif %}
{% endif %}
{% if machine.extra_user %}
{%   if machine.extra_user.password_hash |d(False) == '!' %}
    in-target passwd -l {{ machine.extra_user.name }}; \
{%   endif %}
{%   if machine.extra_user.ssh_pub_keys |d([]) %}
    in-target mkdir -p /home/{{ machine.extra_user.name }}/.ssh; \
{%     for entry in machine.extra_user.ssh_pub_keys |d([]) %}
    printf "# {{ entry.name |d('') }}\n{{ entry.key }}\n" >> /target/home/{{ machine.extra_user.name }}/.ssh/authorized_keys; \
{%     endfor %}
{%   endif %}
{%   if machine.extra_user.sudo %}
    addgroup {{ machine.extra_user.name }} sudo; \
{%     if machine.extra_user.sudo == 'nopass' %}
    echo "{{ machine.extra_user.name }} ALL=(ALL:ALL) NOPASSWD:ALL" >/target/etc/sudoers.d/{{ machine.extra_user.name }}; \
{%     endif %}
{%   endif %}
{% endif %}
    in-target chown -R {{ machine.extra_user.name }}:{{ machine.extra_user.name }} /home/{{ machine.extra_user.name }}; \
    in-target chmod -R 750 /home/{{ machine.extra_user.name }}; \
    echo DONE

# Avoid that last message about the install being complete.
d-i finish-install/reboot_in_progress note

# This will power off the machine instead of just halting it.
d-i debian-installer/exit/poweroff boolean true

